if(!dojo._hasResource["com.ibm.mm.builder.navigationHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.navigationHelper"] = true;
dojo.provide("com.ibm.mm.builder.navigationHelper");

dojo.require("com.ibm.data.EnablerModelStore");
dojo.require("com.ibm.data.EnablerTreeModel");
dojo.require("com.ibm.data.SelectionModel");

dojo.declare("com.ibm.mm.builder.navigationHelper",
		null,
		{
			loaded: false,
			init: function(){
				// singleton instance of data store to be used under the covers by any component using these APIs
				this.store = new com.ibm.data.EnablerModelStore();
				this.navigationUtil = com.ibm.mm.builder.utils.navigationUtil;
				this.pageUtil = com.ibm.mm.builder.utils.pageUtil;
				this.spaceUtil = com.ibm.mm.builder.utils.spaceUtil;
				
				// TEMP for portal, does not cause issues in mashups 2.5
				var nm = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
				
				var currentPage = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage();
				var currentPageId = currentPage.getID();
				if(!currentPageId) {
					var spaceId = this.spaceUtil.getCurrentSpaceId();
					currentPageId = spaceId ? this.pageUtil.getFirstPageInSpace(spaceId) : this.pageUtil.getFirstRootPageId();
					
					if(!currentPageId && spaceId){
						currentPageId = spaceId;
					}else{
						currentPageID = this.navigationUtil.getNavigationRootNode().getID();
					}
				}
				
				var onComplete = dojo.hitch(this,
											function(items) {
												this.treeModel = 
													new com.ibm.data.EnablerTreeModel({
														newItem: function(args) {
															args.label = args.title;
															return this.inherited("newItem", arguments);
														},
														root: items[items.length - 1],
														store: this.store
													});
												
												this.selectionModel = 
													new com.ibm.data.SelectionModel({
														treeModel: this.treeModel,
														selectionPath: items
													});
												
												this.loaded = true;
											} );
				
				var args = { onComplete: onComplete,
							 onError: function(err) {
										console.error(err);
										throw err;
									  },
							 query: {uri: currentPageId }
						   }
				
				if(!this.treeModel || !this.selectionModel) this.store.fetch(args);
			},
			getStore: function(){
				return this.store;
			},
			getTreeModel: function(){
				return this.treeModel;
			},
			getSelectionModel: function(){
				return this.selectionModel;
			}
	}
);

com.ibm.mm.builder.navigationHelper = new com.ibm.mm.builder.navigationHelper();

}
