/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.runtime.skin.ModifiableRuntimeSkinNode");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.runtime.skin.RuntimeSkinNode");
dojo.require("com.ibm.mashups.enabler.runtime.skin.Constants");


/**
 * Interface representing a modifiable runtime skin node.
 * @ibm-api
 * @ibm-module CoreModel
 * @since 2.4
 */
dojo.declare( "com.ibm.mashups.enabler.runtime.skin.ModifiableRuntimeSkinNode", com.ibm.mashups.enabler.runtime.skin.RuntimeSkinNode, {
	/**
     * Checks new style attributes for the layout node represented by this runtime skin node. This causes the <code>onChangingStyle()</code> method to be called on the
     * &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.StyleFilter StyleFilters} for
     * this runtime skin node, allowing them to agree or disagree on the new style attributes.
     * @param {JSON} style style attributes as a JSON object. Must not be <code>null</code>.  For example:<br>
     * <code>&#123; <br>
     * &nbsp;&nbsp;position: "absolute",<br>
     * &nbsp;&nbsp;left: "18px", <br>
     * &nbsp;&nbsp;width: "400px", <br>
     * &nbsp;&nbsp;height: "325px", <br>
     * &nbsp;&nbsp;z-index "51", <br>
     * &#125; </code><br>
     * @return {Boolean} <code>true</code> if the new style is acceptable to the registered filters, 
     *                   <code>false</code> otherwise
     */
    checkStyle: function(style) {
    },
	
    /**
     * Sets the style attributes of the layout node represented by this runtime skin node, causing the <code>onChangeStyle()</code> method to be called on the
     * &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.StyleFilter StyleFilters} for
     * this runtime skin node.
     * @param {JSON} style style attributes as a JSON object. Must not be <code>null</code>.  For example:<br>
     * <code>&#123; <br>
     * &nbsp;&nbsp;position: "absolute",<br>
     * &nbsp;&nbsp;left: "18px", <br>
     * &nbsp;&nbsp;width: "400px", <br>
     * &nbsp;&nbsp;height: "325px", <br>
     * &nbsp;&nbsp;z-index "51", <br>
     * &#125; </code><br>
     * @type void
     */
    setStyle: function(style) {
    },
    
    /**
     * Sets the value of a client side dynamic content. See &nbsp; {@link com.ibm.mashups.enabler.runtime.skin.Constants Constants} for dynamic content name constants
     * @param {String} name name of the client side dynamic content spot to set. May not be <code>null</code>
     * @param {String} value value of the client side dynamic content spot. If <code>null</code>, then the value for this dynamic content spot will be cleared
     * @type void
     * @see com.ibm.mashups.enabler.runtime.skin.Constants
     */
    setDynamicContent: function(name, value) {
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.runtime.skin.RuntimeSkinNodeImpl");

