/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.space.SpaceNode");

dojo.require("com.ibm.mashups.enabler.Identifiable");
dojo.require("com.ibm.mashups.enabler.ModifiableLocalized");
dojo.require("com.ibm.mashups.enabler.DefaultLocalized");
dojo.require("com.ibm.mashups.enabler.ModifiableMetaData");
dojo.require("com.ibm.mashups.enabler.ThemeProvider");
//<INTERFACE>
/**
 * Interface representing a space node.
 * @ibm-api
 * @ibm-module SpaceModel
 */
dojo.declare("com.ibm.mashups.enabler.space.SpaceNode", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.DefaultLocalized, com.ibm.mashups.enabler.ModifiableMetaData, com.ibm.mashups.enabler.ThemeProvider], {
    /**
     * Returns the root navigation ID, or <code>null</code> if no navigation has been
     * associated with the node.
     * @type com.ibm.mashups.enabler.Identifiable
     * @return the root navigation ID, or <code>null</code> if it has not been associated
     */
    getRootNavigation: function(){
    },
    
    /**
     * Returns a URL to export the space in zip file format
     * @type String
     * @return link to export the space
     */
    getExportSpaceURL: function(){
    },
    
    /**
     * Returns a URL to export the space as a template
     * in zip file format
     * @type String
     * @return link to export the space as a template
     */
    getExportTemplateURL: function(){
    },
    
    /**
     * Save the space as template.
     * @type void
     * @return template object.
     */
    saveAsTemplate: function(){
    },
    
    /**
     * Returns whether this space node is flagged as hidden. It is the responsibility of the
     * UI to render the space nodes correctly and honor this flag.
     * @type Boolean
     * @return true if the space is flagged as hidden, otherwise false
     */
    isHidden: function(){
    },
    
    /**
     * Allows to flag the space node as hidden or visible.
     * @param {Boolean} hide true to hide the space, otherwise false
     * @type void
     */
    setHidden: function(hide){
    },
    /**
     * Confirms whether setting the hidden flag is possible.
     * @param {Boolean} hide true to hide the space, otherwise false
     * @return {Boolean} true if the value can be set, otherwise false.
     */
    confirmSetHidden: function(hide){
    },
    
    /**
     * Returns whether this space node is flagged as a favorite space.
     * @type Boolean
     * @return true if the space is flagged as favorite, otherwise false
     */
    isFavorite: function(){
    },
    
    /**
     * Allows to mark the space node as favorite ir non-favorite.
     * @param {Boolean} favorite true to mark this space as favorite, otherwise false
     * @type void
     */
    setFavorite: function(favorite){
    }
});

//</INTERFACE>
dojo.require("com.ibm.mm.enabler.space.SpaceNodeImpl");
