/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.widget.ModifiableEventProvider");

dojo.require("com.ibm.mashups.enabler.widget.EventProvider");
dojo.require("com.ibm.mashups.enabler.widget.ModifiableEvent");
dojo.require("com.ibm.mashups.enabler.DirtyFlagProvider");

/**
 * Interface for a modifiable widget event provider.
 *
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.ModifiableEventProvider", [com.ibm.mashups.enabler.widget.EventProvider, com.ibm.mashups.enabler.DirtyFlagProvider], {
    /**
     * Creates an&nbsp; {@link Event Event} with the given name.
     * @param {String} name the name of the event
     * @param {boolean} handled if <tt>true</tt> the created event will be &quot;handled&quot;, otherwiseit will be &quot;published&quot;
     * @return {com.ibm.mashups.enabler.widget.Event} the newly created event with name
     */
    createEvent: function(name, handled) {
        
    },
    /**
     * Returns wigdet events.
     *
     * @return {com.ibm.mashups.enabler.widget.ModifiableEvent[]} widget events
     */
    getEvents: function(filter){
    },
    /**
     * Returns the event identified by <tt>name</tt> or <tt>null</tt> if the event doesn't exist
     * in this provider.
     * @param {String} name the name of the&nbsp; {@link Event Event}.
     * @return {com.ibm.mashups.enabler.widget.ModifiableEvent} the event identified by <tt>name</tt> or <tt>null</tt>.
     */
    getEvent: function(name) {
        
    },
    /**
     * Adds an Event to this&nbsp; {@link EventProvider EventProvider}. If the event already exists
     * it will be overwritten, otherwise it will be added. 
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to add to this event provider
     * @return {void}
     */
    addEvent: function(event) {
        
    },
    /**
     * Removes an Event from this&nbsp; {@link EventProvider EventProvider}.
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to add to this event provider
     * @return {void}
     */
    removeEvent: function(event) {
        
    },
    /**
     * Indicates if the specified event may be added.
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to add
     * @return {boolean} <code>true</code> in case the event may be added, <code>false</code> otherwise
     */
    confirmAddEvent: function(event) {
        
    },
    /**
     * Indicates if the given event may be removed. 
     * @param {com.ibm.mashups.enabler.widget.Event} event the event to remove
     * @return {boolean} <code>true</code> in case the preference may be removed, <code>false</code> otherwise
     */
    confirmRemoveEvent: function(event) {
        
    }
});
